#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "et199_32.h"

struct ET_CONTEXT pContext[32];
unsigned char FileBuff[10240];
unsigned char InBuf[256],OutBuf[256];

char szAtr[MAX_ATR_LEN+1]; 
	
void PostError(char * Perfix, unsigned long dwErr)
{
	char sErr[128];
	//
	memset(sErr, 0, sizeof(sErr));
	ETFormatErrorMessage(dwErr,sErr,sizeof(sErr));
	printf("%s Error:%s\r\n",Perfix,sErr);
	 printf("Press Enter to quit!\r\n");
  
		 getchar();
}

int main(int argc, char* argv[])
{
	int   i;
	unsigned long dwRet;
	unsigned long Frq     = 5;   //0.5 seconds twinkle again
	int  dwCount = 0;
	unsigned long TokenSize,DFSize;
	unsigned short id = 0x1001;
	COS_RSA_PUBLIC_KEY_1024 pubKeyData;
	COS_RSA_CRT_PRIVATE_KEY_1024 priKeyData;
	unsigned long pubSize = sizeof(COS_RSA_PUBLIC_KEY_1024),priSize = sizeof(COS_RSA_CRT_PRIVATE_KEY_1024);
	unsigned long FileSize;
	FILE* fp;
	struct EFINFO* pefi;
	char ch;
  printf("Press Enter to continue!\r\n");
  
  getchar();
	//Enumeration ET199 and returns quantity
	dwRet=ETEnum(0,&dwCount);
	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
	{
		PostError("ETEnum 1",dwRet);
		return dwRet;
	}	
	memset(pContext,0,sizeof(struct ET_CONTEXT)*dwCount);
	//Use the allocated buffer to re-run enumeration
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
	{
		PostError("ETEnum 2",dwRet);
		return dwRet;
	}
    //
	printf("Find ET199 %d\n",dwCount);
	//Open ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
	{
		PostError("ETOpen",dwRet);
		return dwRet;
	}
	//
	printf("Open ET199: \n");
	printf("COS Version: %lu.%02lu\n",pContext[0].dwVersion>>8 & 0xff,pContext[0].dwVersion & 0xff);
	printf("HardSerial: ");
	for(i=0;i<8;i++) printf("%02X",pContext[0].bID[i]);
	printf("\n");
	printf("ATR:%s\n",pContext[0].bAtr);
	printf("Customer:%lu\n",pContext[0].dwCustomer);
    //
	if(pContext[0].dwCustomer != 0x1234) //Replace a number of own clients
	{
		//Process the dongle that is not your own(closed lock, etc.)
	}		
	//Setting LED lights flashing, frequency is Frq
	dwRet = ETControl(&pContext[0],ET_LED_WINK,(unsigned char *)&Frq,sizeof(Frq),(unsigned char *)NULL,0,NULL);
	if(dwRet)
	{
		PostError("ETControl ET_LED_WINK",dwRet);
		return dwRet;
	}
	//
	printf("\nPlease press Enter 1");
    getchar();
    //
    	memset((unsigned char *)&TokenSize, 0, sizeof(TokenSize));
	dwRet = ETControl(&pContext[0],ET_GET_DEVICE_USABLE_SPACE,(unsigned char *)NULL,0,(unsigned char *)&TokenSize,4,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		return dwRet;
	}
	//
	printf("TokenSize:%luK\n",TokenSize/1024);
	//Switch to the root directory, check whether the root directory exists	
	dwRet = ETChangeDir(&pContext[0],"\\");
	if(!dwRet)
	{
		//Use the default developers, if not the default password verify password, here need to replace into your password
		dwRet = ETVerifyPin(&pContext[0],ET_DEFAULT_DEV_PIN,ET_DEV_PIN_LEN,ET_DEV_PIN);
		if(dwRet)
		{
			PostError("ETVerifyPin",dwRet);
			return dwRet;
		}
		//Delete the root directory
		dwRet = ETEraseDir(&pContext[0],NULL);
		if(dwRet)
		{
			PostError("ETEraseDir",dwRet);
			return dwRet;
		}
	}	
	//Create the root directory
	dwRet = ETCreateDir(&pContext[0],NULL,0,ET_CREATE_ROOT_DIR);
	if(dwRet)
	{
		PostError("ETCreateDir",dwRet);
		return dwRet;
	}
	//Use the default developers, if not the default password verify password, here need to replace into your password
	dwRet = ETVerifyPin(&pContext[0],ET_DEFAULT_DEV_PIN,ET_DEV_PIN_LEN,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		return dwRet;
	}
	//Set ATR
	dwRet = ETControl(&pContext[0],ET_SET_DEVICE_ATR,"ET199 VC TEST PROJECT           ",MAX_ATR_LEN,NULL,0,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		return dwRet;
	}
	//Get ATR
	dwRet = ETControl(&pContext[0],ET_GET_DEVICE_ATR,NULL,0,szAtr,MAX_ATR_LEN,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		return dwRet;
	}
	//
	szAtr[MAX_ATR_LEN] = 0;
    //
	printf("New Atr: %s\n",szAtr);	
	//Verify the developers password
	dwRet = ETChangePin(&pContext[0],(unsigned char *)"123456781234567812345678",24,(unsigned char *)"876543218765432187654321",24,ET_DEV_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		return dwRet;
	}
	//
	dwRet = ETChangePin(&pContext[0],(unsigned char *)"876543218765432187654321",24,(unsigned char *)"123456781234567812345678",24,ET_DEV_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		return dwRet;
	}	
	//Verify the user password
	dwRet = ETChangePin(&pContext[0],(unsigned char *)"12345678",8,(unsigned char *)"87654321",8,ET_USER_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		return dwRet;
	}
	//
	dwRet = ETChangePin(&pContext[0],(unsigned char *)"87654321",8,(unsigned char *)"12345678",8,ET_USER_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		return dwRet;
	}
	//For the directory operation, need validation developers password
	dwRet = ETVerifyPin(&pContext[0],(unsigned char *)"123456781234567812345678",24,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		return dwRet;
	}	
	//Establish a subdirectory as an application
	dwRet = ETCreateDir(&pContext[0],"2000",60000,ET_CREATE_SUB_DIR);
	if(dwRet)
	{
		PostError("ETCreateDir",dwRet);
		return dwRet;
	}
	//Because the current directory automaticaly enter into subdirectories after creating directories, We need verify developers password.ڴĿ¼ǰĿ¼ԶĿ¼Ҫ֤̿
	dwRet = ETVerifyPin(&pContext[0],(unsigned char *)"123456781234567812345678",24,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		return dwRet;
	}
	//establish 5 types of files
	dwRet = ETCreateFile(&pContext[0],"1001",1024,0);//Executable file
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		return dwRet;
	}
	//
	printf("Create file 1001 \n");
    //
	dwRet = ETCreateFile(&pContext[0],"1002",1024,1);//Data files
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		return dwRet;
	}
	//
	printf("Create file 1002 \n");
    //
	dwRet = ETCreateFile(&pContext[0],"1003",1024,2);//Public-key files
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		return dwRet;
	}
	//
	printf("Create file 1003 \n");
    //
	dwRet = ETCreateFile(&pContext[0],"1004",1024,3);//private-key files
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		return dwRet;
	}
	//
	printf("Create file 1004 \n");
    //
	dwRet = ETCreateFile(&pContext[0],"1005",1024,4);//Internal executable file
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		return dwRet;
	}
	//
	printf("Create file 1005 \n");
    //
    	memset((unsigned char *)&DFSize, 0, sizeof(DFSize));
	dwRet = ETControl(&pContext[0],ET_GET_DF_AVAILABLE_SPACE,NULL,0,(unsigned char *)&DFSize,4,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		return dwRet;
	}
	//
	printf("Current DF available size %lu Bytes\n",DFSize);
	//========================================
	printf("GET_EF_INFO \n");
	memset(InBuf,0,sizeof(InBuf));
	memset(OutBuf,0,sizeof(OutBuf));
	//
	strcpy((char*)InBuf, "1002");
	dwRet = ETControl(&pContext[0], ET_GET_EF_INFO, InBuf, strlen(InBuf), OutBuf, sizeof(OutBuf), &FileSize);
	if(dwRet)
	{
		PostError("ETGenRsaKey",dwRet);
		return dwRet;
	}
	//
	pefi = (struct EFINFO *)OutBuf;
	printf("GET_EF_INFO %04X - %02X - %04X  %02X return FileSize %lu\n", pefi->wFileID, pefi->bFileType, pefi->wFileSize, OutBuf[5], FileSize);
  //=======================================
	dwRet = ETGenRsaKey(&pContext[0],1024,65537,"1003","1004",(unsigned char *)&pubKeyData,&pubSize,(unsigned char *)&priKeyData,&priSize);
	if(dwRet)
	{
		PostError("ETGenRsaKey",dwRet);
		return dwRet;
	}
	//================
	fp = fopen("hardware.c51", "rb");  //Binary read-only
    if(fp == 0)
	{
		PostError("fopen",0);
		return ET_E_LOAD_FILE_FAILED;
	}	
    //get file leng
	fseek(fp,0,SEEK_END);
    FileSize = ftell(fp);
	//
	memset(FileBuff, 0, sizeof(FileBuff));
	fseek(fp,0,SEEK_SET);
	fread(FileBuff,FileSize,1,fp);
	//
	fclose(fp);    
    //================
	dwRet = ETWriteFile(&pContext[0],"1001",0,FileBuff,FileSize);
	if(dwRet)
	{
		PostError("ETWriteFile",dwRet);
		return dwRet;
	}
    //
	dwRet = ETVerifyPin(&pContext[0],(unsigned char *)"12345678",8,ET_USER_PIN);
	//
	*((unsigned short *)InBuf) = 8;//Calculation of factorial 8
	dwRet = ETExecute(&pContext[0],"1001",InBuf,2,OutBuf,128,NULL);
	if(dwRet)
	{
		PostError("ETExecute",dwRet);
		return dwRet;
	}
	//
	printf("Execute result 8! = %lu\n",*((unsigned long *)OutBuf));

    //
	printf("\nPlease press Enter 2");
    getchar();
	//*******Initial empty locked state***********
	//printf("ETChangeDir_before.\n");	
	ETChangeDir(&pContext[0],"\\");
	//For directory operation, need validation developers password
	//printf("ETVerifyPin_before.\n");
	dwRet = ETVerifyPin(&pContext[0],(unsigned char *)"123456781234567812345678",24,ET_DEV_PIN);
	//printf("ETVerfyPin_after.\n");
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		return dwRet;
	}	
	//Delete the root directory
	dwRet = ETEraseDir(&pContext[0],NULL);
	if(dwRet)
	{
		PostError("ETEraseDir",dwRet);
		return dwRet;
	}	
	//Create the root directory
	dwRet = ETCreateDir(&pContext[0],NULL,0,ET_CREATE_ROOT_DIR);
	if(dwRet)
	{
		PostError("ETCreateDir",dwRet);
		return dwRet;
	}
	printf("Create root directory.\n");
	//Set LED lamp lighting
	dwRet = ETControl(&pContext[0],ET_LED_UP,NULL,0,NULL,0,NULL);
	if(dwRet)
	{
		PostError("ETControl ET_LED_UP",dwRet);
		return dwRet;
	}
	printf("LED lamp lighting.\n");
    //
    	//printf("ETClose.\n");
	ETClose(&pContext[0]);
	//printf("dwRet.\n");
    //
	printf("Test success!\n");
	printf("Press Enter to quit!\r\n");
  
	getchar();
	return dwRet;
}
